# Flux releaser

## Usage

```bash
mkdir -p some/path

mkdir -p some/path/someEnvironment
touch some/path/someEnvironment/someFile.txt

# Should be run from a ci pipeline

flux-releaser commit \
  --app someApp \
  --branch someBranch \
  --include some/path \
  --registry https://flux-releaser.i.kjuulh.io
```

!!! note
    include path should include a sub folder for each releaseable artifact

flux releaser can also be used as a library, which is especially useful if integrated with dagger

Now you can release or auto-release this your desired environment and app

```bash
flux-releaser release \
  --app someApp \
  --branch someBranch \
  --registry https://flux-releaser.i.kjuulh.io
```

If cuddle.yaml is available it will automatically include required information from its references

```bash
flux-releaser release --branch someBranch
```

## Install

### Client & CI

Flux releaser is a rust app used client side and in CI as a cli app (flux-releaser), or alternatively as a rust library.

### Registry

Flux releaser requires a server to function. Said flux is packaged in a helm chart, and is available at `tbd`, if the helm chart is used, it will stand-up a cockroach cluster and minio for artifacts.

Flux releaser also requires a connection to a flux gitops registry. This is provided to the flux app on the server via. a toml file (see configuration), but the defaults should work fine.
